// Code generated by genpjrpc. DO NOT EDIT.
//  genpjrpc version: v0.1.0

package rpcserver

import (
	"context"
	"encoding/json"
	"fmt"
	"helloworld/model/types"

	pjrpc "gitlab.com/pjrpc/pjrpc/v2"
	"gitlab.com/pjrpc/pjrpc/v2/pjson"
)

// List of the server JSON-RPC methods.
const (
	JSONRPCMethodHelloMethod = "hello_method"
)

// HelloServiceServer is an API server for HelloService service.
type HelloServiceServer interface {
	// HelloMethod documentation of the Hello RPC method.
	// Name of the method will convert to 'hello_method' (snake_case) JSON-RPC method.
	// You must use named Go type as request and response of the method.
	// Also you can use special magic comment to pass some settings for swagger spec.
	// See README for details: //genpjrpc:params.
	HelloMethod(ctx context.Context, in *types.HelloRequest) (*types.HelloResponse, error)
}

type regHelloService struct {
	svc HelloServiceServer
}

// RegisterHelloServiceServer registers rpc handlers with middlewares in the server router.
func RegisterHelloServiceServer(srv pjrpc.Registrator, svc HelloServiceServer, middlewares ...pjrpc.Middleware) {
	r := &regHelloService{svc: svc}

	srv.RegisterMethod(JSONRPCMethodHelloMethod, r.regHelloMethod)

	srv.With(middlewares...)
}

func (r *regHelloService) regHelloMethod(ctx context.Context, params json.RawMessage) (interface{}, error) {
	in := new(types.HelloRequest)
	if params != nil {
		if err := pjson.Unmarshal(params, in); err != nil {
			return nil, pjrpc.JRPCErrParseError("failed to parse params")
		}
	}

	res, err := r.svc.HelloMethod(ctx, in)
	if err != nil {
		return nil, fmt.Errorf("failed HelloMethod: %w", err)
	}

	return res, nil
}
